/* 
------------------------------------------------------------
	CJO Selectbox Javascript
	by: John Ryan Acoba
    Senior GUI Designer 
------------------------------------------------------------
*/

 /*
 *  jQuery selectbox - A cosmetic, styleable replacement for SELECT elements
 *
 *  Copyright 2012 Cory LaViska for A Beautiful Site, LLC.
 *
 *  https://github.com/claviska/jquery-selectbox
 *
 *  Licensed under both the MIT license and the GNU GPLv2 (same as jQuery: http://jquery.org/license)
 *
 */
 
/* jQuery selectbox control start */

jQuery(document).ready( function() {

				//
				// Enable selectbox control and bind events
				//

				jQuery("#create").click( function() {
					jQuery("SELECT").selectbox();
				});

				jQuery("#destroy").click( function() {
					jQuery("SELECT").selectbox('destroy');
				});

				jQuery("#enable").click( function() {
					jQuery("SELECT").selectbox('enable');
				});

				jQuery("#disable").click( function() {
					jQuery("SELECT").selectbox('disable');
				});

				jQuery("#serialize").click( function() {
					jQuery("#console").append('<br />-- Serialized data --<br />' + jQuery("FORM").serialize().replace(/&/g, '<br />') + '<br /><br />');
					jQuery("#console")[0].scrollTop = jQuery("#console")[0].scrollHeight;
				});

				jQuery("#value-1").click( function() {
					jQuery("SELECT").selectbox('value', 1);
				});

				jQuery("#value-2").click( function() {
					jQuery("SELECT").selectbox('value', 2);
				});

				jQuery("#value-2-4").click( function() {
					jQuery("SELECT").selectbox('value', [2, 4]);
				});

				jQuery("#options").click( function() {
					jQuery("SELECT").selectbox('options', {

						'Opt Group 1': {
							'1': 'Value 1',
							'2': 'Value 2',
							'3': 'Value 3',
							'4': 'Value 4',
							'5': 'Value 5'
						},
						'Opt Group 2': {
							'6': 'Value 6',
							'7': 'Value 7',
							'8': 'Value 8',
							'9': 'Value 9',
							'10': 'Value 10'
						},
						'Opt Group 3': {
							'11': 'Value 11',
							'12': 'Value 12',
							'13': 'Value 13',
							'14': 'Value 14',
							'15': 'Value 15'
						}

					});
				});

				jQuery("#default").click( function() {
					jQuery("SELECT").selectbox('settings', {
						'menuTransition': 'default',
						'menuSpeed' : 0
					});
				});

				jQuery("#fade").click( function() {
					jQuery("SELECT").selectbox('settings', {
						'menuTransition': 'fade',
						'menuSpeed' : 'fast'
					});
				});

				jQuery("#slide").click( function() {
					jQuery("SELECT").selectbox('settings', {
						'menuTransition': 'slide',
						'menuSpeed' : 'fast'
					});
				});


				jQuery("SELECT")
					.selectbox()
					.focus( function() {
						jQuery("#console").append('Focus on ' + jQuery(this).attr('name') + '<br />');
						jQuery("#console")[0].scrollTop = jQuery("#console")[0].scrollHeight;
					})
					.blur( function() {
						jQuery("#console").append('Blur on ' + jQuery(this).attr('name') + '<br />');
						jQuery("#console")[0].scrollTop = jQuery("#console")[0].scrollHeight;
					})
					.change( function() {
						jQuery("#console").append('Change on ' + jQuery(this).attr('name') + ': ' + jQuery(this).val() + '<br />');
						jQuery("#console")[0].scrollTop = jQuery("#console")[0].scrollHeight;
					});

			});
			
/* jQuery selectbox control end */

 
/* jQuery selectbox start */
 
if (jQuery)(function(jQuery) {
	jQuery.extend(jQuery.fn, {
		selectbox: function(method, data) {
			var typeTimer, typeSearch = '',
				isMac = navigator.platform.match(/mac/i);
			//
			// Private methods
			//
			var init = function(select, data) {
					var options;
					// Disable for iOS devices (their native controls are more suitable for a touch device)
					if (navigator.userAgent.match(/iPad|iPhone|Android|IEMobile|BlackBerry/i)) return false;
					// Element must be a select control
					if (select.tagName.toLowerCase() !== 'select') return false;
					select = jQuery(select);
					if (select.data('selectbox-control')) return false;
					var control = jQuery('<a class="selectbox" />'),
						inline = select.attr('multiple') || parseInt(select.attr('size')) > 1;
					var settings = data || {};
					control.width(select.outerWidth()).addClass(select.attr('class')).attr('title', select.attr('title') || '').attr('tabindex', parseInt(select.attr('tabindex'))).css('display', 'inline-block').bind('focus.selectbox', function() {
						if (this !== document.activeElement && document.body !== document.activeElement) jQuery(document.activeElement).blur();
						if (control.hasClass('selectbox-active')) return;
						control.addClass('selectbox-active');
						select.trigger('focus');
					}).bind('blur.selectbox', function() {
						if (!control.hasClass('selectbox-active')) return;
						control.removeClass('selectbox-active');
						select.trigger('blur');
					});
					if (!jQuery(window).data('selectbox-bindings')) {
						jQuery(window).data('selectbox-bindings', true).bind('scroll.selectbox', hideMenus).bind('resize.selectbox', hideMenus);
					}
					if (select.attr('disabled')) control.addClass('selectbox_disabled');
					// Focus on control when label is clicked
					select.bind('click.selectbox', function(event) {
						control.focus();
						event.preventDefault();
					});
					// Generate control
					if (inline) {
						//
						// Inline controls
						//
						options = getOptions(select, 'inline');
						control.append(options).data('selectbox_options', options).addClass('selectbox_inline selectbox-menuShowing').bind('keydown.selectbox', function(event) {
							handleKeyDown(select, event);
						}).bind('keypress.selectbox', function(event) {
							handleKeyPress(select, event);
						}).bind('mousedown.selectbox', function(event) {
							if (jQuery(event.target).is('A.selectbox_inline')) event.preventDefault();
							if (!control.hasClass('selectbox-focus')) control.focus();
						}).insertAfter(select);
						// Auto-height based on size attribute
						if (!select[0].style.height) {
							var size = select.attr('size') ? parseInt(select.attr('size')) : 5;
							// Draw a dummy control off-screen, measure, and remove it
							var tmp = control.clone().removeAttr('id').css({
								position: 'absolute',
								top: '-9999em'
							}).show().appendTo('body');
							tmp.find('.selectbox_options').html('<li><a>\u00A0</a></li>');
							var optionHeight = parseInt(tmp.find('.selectbox_options A:first').html('&nbsp;').outerHeight());
							tmp.remove();
							control.height(optionHeight * size);
						}
						disableSelection(control);
					} else {
						//
						// Dropdown controls
						//
						var label = jQuery('<span class="selectbox_label" />'),
							arrow = jQuery('<span class="selectbox_arrow" />');
						// Update label
						label.attr('class', getLabelClass(select)).text(getLabelText(select));
						options = getOptions(select, 'dropdown');
						options.appendTo('BODY');
						control.data('selectbox_options', options).addClass('selectbox').append(label).append(arrow).bind('mousedown.selectbox', function(event) {
							if (control.hasClass('selectbox-menuShowing')) {
								hideMenus();
							} else {
								event.stopPropagation();
								// Webkit fix to prevent premature selection of options
								options.data('selectbox-down-at-x', event.screenX).data('selectbox-down-at-y', event.screenY);
								showMenu(select);
							}
						}).bind('keydown.selectbox', function(event) {
							handleKeyDown(select, event);
						}).bind('keypress.selectbox', function(event) {
							handleKeyPress(select, event);
						}).bind('open.selectbox', function(event, triggerData) {
							if (triggerData && triggerData._selectbox === true) return;
							showMenu(select);
						}).bind('close.selectbox', function(event, triggerData) {
							if (triggerData && triggerData._selectbox === true) return;
							hideMenus();
						}).insertAfter(select);
						// Set label width
						var labelWidth = control.width() - arrow.outerWidth() - parseInt(label.css('paddingLeft')) - parseInt(label.css('paddingLeft'));
						label.width(labelWidth);
						disableSelection(control);
					}
					// Store data for later use and show the control
					select.addClass('selectbox').data('selectbox-control', control).data('selectbox-settings', settings).hide();
				};
			var getOptions = function(select, type) {
					var options;
					// Private function to handle recursion in the getOptions function.
					var _getOptions = function(select, options) {
							// Loop through the set in order of element children.
							select.children('OPTION, OPTGROUP').each(function() {
								// If the element is an option, add it to the list.
								if (jQuery(this).is('OPTION')) {
									// Check for a value in the option found.
									if (jQuery(this).length > 0) {
										// Create an option form the found element.
										generateOptions(jQuery(this), options);
									} else {
										// No option information found, so add an empty.
										options.append('<li>\u00A0</li>');
									}
								} else {
									// If the element is an option group, add the group and call this function on it.
									var optgroup = jQuery('<li class="selectbox_optgroup" />');
									optgroup.text(jQuery(this).attr('label'));
									options.append(optgroup);
									options = _getOptions(jQuery(this), options);
								}
							});
							// Return the built strin
							return options;
						};
					switch (type) {
					case 'inline':
						options = jQuery('<ul class="selectbox_options" />');
						options = _getOptions(select, options);
						options.find('A').bind('mouseover.selectbox', function(event) {
							addHover(select, jQuery(this).parent());
						}).bind('mouseout.selectbox', function(event) {
							removeHover(select, jQuery(this).parent());
						}).bind('mousedown.selectbox', function(event) {
							event.preventDefault(); // Prevent options from being "dragged"
							if (!select.selectbox('control').hasClass('selectbox-active')) select.selectbox('control').focus();
						}).bind('mouseup.selectbox', function(event) {
							hideMenus();
							selectOption(select, jQuery(this).parent(), event);
						});
						disableSelection(options);
						return options;
					case 'dropdown':
						options = jQuery('<ul class="selectbox_menu selectbox_options" />');
						options = _getOptions(select, options);
						options.data('selectbox-select', select).css('display', 'none').appendTo('BODY').find('A').bind('mousedown.selectbox', function(event) {
							event.preventDefault(); // Prevent options from being "dragged"
							if (event.screenX === options.data('selectbox-down-at-x') && event.screenY === options.data('selectbox-down-at-y')) {
								options.removeData('selectbox-down-at-x').removeData('selectbox-down-at-y');
								hideMenus();
							}
						}).bind('mouseup.selectbox', function(event) {
							if (event.screenX === options.data('selectbox-down-at-x') && event.screenY === options.data('selectbox-down-at-y')) {
								return;
							} else {
								options.removeData('selectbox-down-at-x').removeData('selectbox-down-at-y');
							}
							selectOption(select, jQuery(this).parent());
							hideMenus();
						}).bind('mouseover.selectbox', function(event) {
							addHover(select, jQuery(this).parent());
						}).bind('mouseout.selectbox', function(event) {
							removeHover(select, jQuery(this).parent());
						});
						// Inherit classes for dropdown menu
						var classes = select.attr('class') || '';
						if (classes !== '') {
							classes = classes.split(' ');
							for (var i in classes) options.addClass(classes[i] + '-selectbox_menu');
						}
						disableSelection(options);
						return options;
					}
				};
			var getLabelClass = function(select) {
					var selected = jQuery(select).find('OPTION:selected');
					return ('selectbox_label ' + (selected.attr('class') || '')).replace(/\s+$/, '');
				};
			var getLabelText = function(select) {
					var selected = jQuery(select).find('OPTION:selected');
					return selected.text() || '\u00A0';
				};
			var setLabel = function(select) {
					select = jQuery(select);
					var control = select.data('selectbox-control');
					if (!control) return;
					control.find('.selectbox_label').attr('class', getLabelClass(select)).text(getLabelText(select));
				};
			var destroy = function(select) {
					select = jQuery(select);
					var control = select.data('selectbox-control');
					if (!control) return;
					var options = control.data('selectbox_options');
					options.remove();
					control.remove();
					select.removeClass('selectbox').removeData('selectbox-control').data('selectbox-control', null).removeData('selectbox-settings').data('selectbox-settings', null).show();
				};
			var refresh = function(select) {
					select = jQuery(select);
					select.selectbox('options', select.html());
				};
			var showMenu = function(select) {
					select = jQuery(select);
					var control = select.data('selectbox-control'),
						settings = select.data('selectbox-settings'),
						options = control.data('selectbox_options');
					if (control.hasClass('selectbox_disabled')) return false;
					hideMenus();
					var borderBottomWidth = isNaN(control.css('borderBottomWidth')) ? 0 : parseInt(control.css('borderBottomWidth'));
					// Menu position
					options.width(control.innerWidth()).css({
						top: control.offset().top + control.outerHeight() - borderBottomWidth,
						left: control.offset().left
					});
					if (select.triggerHandler('beforeopen')) return false;
					var dispatchOpenEvent = function() {
							select.triggerHandler('open', {
								_selectbox: true
							});
						};
					// Show menu
					switch (settings.menuTransition) {
					case 'fade':
						options.fadeIn(settings.menuSpeed, dispatchOpenEvent);
						break;
					case 'slide':
						options.slideDown(settings.menuSpeed, dispatchOpenEvent);
						break;
					default:
						options.show(settings.menuSpeed, dispatchOpenEvent);
						break;
					}
					if (!settings.menuSpeed) dispatchOpenEvent();
					// Center on selected option
					var li = options.find('.selectbox_selected:first');
					keepOptionInView(select, li, true);
					addHover(select, li);
					control.addClass('selectbox-menuShowing');
					jQuery(document).bind('mousedown.selectbox', function(event) {
						if (jQuery(event.target).parents().andSelf().hasClass('selectbox_options')) return;
						hideMenus();
					});
				};
			var hideMenus = function() {
					if (jQuery(".selectbox_menu:visible").length === 0) return;
					jQuery(document).unbind('mousedown.selectbox');
					jQuery(".selectbox_menu").each(function() {
						var options = jQuery(this),
							select = options.data('selectbox-select'),
							control = select.data('selectbox-control'),
							settings = select.data('selectbox-settings');
						if (select.triggerHandler('beforeclose')) return false;
						var dispatchCloseEvent = function() {
								select.triggerHandler('close', {
									_selectbox: true
								});
							};
						if (settings) {
							switch (settings.menuTransition) {
							case 'fade':
								options.fadeOut(settings.menuSpeed, dispatchCloseEvent);
								break;
							case 'slide':
								options.slideUp(settings.menuSpeed, dispatchCloseEvent);
								break;
							default:
								options.hide(settings.menuSpeed, dispatchCloseEvent);
								break;
							}
							if (!settings.menuSpeed) dispatchCloseEvent();
							control.removeClass('selectbox-menuShowing');
						} else {
							jQuery(this).hide();
							jQuery(this).triggerHandler('close', {
								_selectbox: true
							});
							jQuery(this).removeClass('selectbox-menuShowing');
						}
					});
				};
			var selectOption = function(select, li, event) {
					select = jQuery(select);
					li = jQuery(li);
					var control = select.data('selectbox-control'),
						settings = select.data('selectbox-settings');
					if (control.hasClass('selectbox_disabled')) return false;
					if (li.length === 0 || li.hasClass('selectbox_disabled')) return false;
					if (select.attr('multiple')) {
						// If event.shiftKey is true, this will select all options between li and the last li selected
						if (event.shiftKey && control.data('selectbox-last-selected')) {
							li.toggleClass('selectbox_selected');
							var affectedOptions;
							if (li.index() > control.data('selectbox-last-selected').index()) {
								affectedOptions = li.siblings().slice(control.data('selectbox-last-selected').index(), li.index());
							} else {
								affectedOptions = li.siblings().slice(li.index(), control.data('selectbox-last-selected').index());
							}
							affectedOptions = affectedOptions.not('.selectbox_optgroup, .selectbox_disabled');
							if (li.hasClass('selectbox_selected')) {
								affectedOptions.addClass('selectbox_selected');
							} else {
								affectedOptions.removeClass('selectbox_selected');
							}
						} else if ((isMac && event.metaKey) || (!isMac && event.ctrlKey)) {
							li.toggleClass('selectbox_selected');
						} else {
							li.siblings().removeClass('selectbox_selected');
							li.addClass('selectbox_selected');
						}
					} else {
						li.siblings().removeClass('selectbox_selected');
						li.addClass('selectbox_selected');
					}
					if (control.hasClass('selectbox')) {
						control.find('.selectbox_label').text(li.text());
					}
					// Update original control's value
					var i = 0,
						selection = [];
					if (select.attr('multiple')) {
						control.find('.selectbox_selected A').each(function() {
							selection[i++] = jQuery(this).attr('rel');
						});
					} else {
						selection = li.find('A').attr('rel');
					}
					// Remember most recently selected item
					control.data('selectbox-last-selected', li);
					// Change callback
					if (select.val() !== selection) {
						select.val(selection);
						setLabel(select);
						select.trigger('change');
					}
					return true;
				};
			var addHover = function(select, li) {
					select = jQuery(select);
					li = jQuery(li);
					var control = select.data('selectbox-control'),
						options = control.data('selectbox_options');
					options.find('.selectbox_hover').removeClass('selectbox_hover');
					li.addClass('selectbox_hover');
				};
			var removeHover = function(select, li) {
					select = jQuery(select);
					li = jQuery(li);
					var control = select.data('selectbox-control'),
						options = control.data('selectbox_options');
					options.find('.selectbox_hover').removeClass('selectbox_hover');
				};
			var keepOptionInView = function(select, li, center) {
					if (!li || li.length === 0) return;
					select = jQuery(select);
					var control = select.data('selectbox-control'),
						options = control.data('selectbox_options'),
						scrollBox = control.hasClass('selectbox') ? options : options.parent(),
						top = parseInt(li.offset().top - scrollBox.position().top),
						bottom = parseInt(top + li.outerHeight());
					if (center) {
						scrollBox.scrollTop(li.offset().top - scrollBox.offset().top + scrollBox.scrollTop() - (scrollBox.height() / 2));
					} else {
						if (top < 0) {
							scrollBox.scrollTop(li.offset().top - scrollBox.offset().top + scrollBox.scrollTop());
						}
						if (bottom > scrollBox.height()) {
							scrollBox.scrollTop((li.offset().top + li.outerHeight()) - scrollBox.offset().top + scrollBox.scrollTop() - scrollBox.height());
						}
					}
				};
			var handleKeyDown = function(select, event) {
					//
					// Handles open/close and arrow key functionality
					//
					select = jQuery(select);
					var control = select.data('selectbox-control'),
						options = control.data('selectbox_options'),
						settings = select.data('selectbox-settings'),
						totalOptions = 0,
						i = 0;
					if (control.hasClass('selectbox_disabled')) return;
					switch (event.keyCode) {
					case 8:
						// backspace
						event.preventDefault();
						typeSearch = '';
						break;
					case 9:
						// tab
					case 27:
						// esc
						hideMenus();
						removeHover(select);
						break;
					case 13:
						// enter
						if (control.hasClass('selectbox-menuShowing')) {
							selectOption(select, options.find('LI.selectbox_hover:first'), event);
							if (control.hasClass('selectbox')) hideMenus();
						} else {
							showMenu(select);
						}
						break;
					case 38:
						// up
					case 37:
						// left
						event.preventDefault();
						if (control.hasClass('selectbox-menuShowing')) {
							var prev = options.find('.selectbox_hover').prev('LI');
							totalOptions = options.find('LI:not(.selectbox_optgroup)').length;
							i = 0;
							while (prev.length === 0 || prev.hasClass('selectbox_disabled') || prev.hasClass('selectbox_optgroup')) {
								prev = prev.prev('LI');
								if (prev.length === 0) {
									if (settings.loopOptions) {
										prev = options.find('LI:last');
									} else {
										prev = options.find('LI:first');
									}
								}
								if (++i >= totalOptions) break;
							}
							addHover(select, prev);
							selectOption(select, prev, event);
							keepOptionInView(select, prev);
						} else {
							showMenu(select);
						}
						break;
					case 40:
						// down
					case 39:
						// right
						event.preventDefault();
						if (control.hasClass('selectbox-menuShowing')) {
							var next = options.find('.selectbox_hover').next('LI');
							totalOptions = options.find('LI:not(.selectbox_optgroup)').length;
							i = 0;
							while (next.length === 0 || next.hasClass('selectbox_disabled') || next.hasClass('selectbox_optgroup')) {
								next = next.next('LI');
								if (next.length === 0) {
									if (settings.loopOptions) {
										next = options.find('LI:first');
									} else {
										next = options.find('LI:last');
									}
								}
								if (++i >= totalOptions) break;
							}
							addHover(select, next);
							selectOption(select, next, event);
							keepOptionInView(select, next);
						} else {
							showMenu(select);
						}
						break;
					}
				};
			var handleKeyPress = function(select, event) {
					//
					// Handles type-to-find functionality
					//
					select = jQuery(select);
					var control = select.data('selectbox-control'),
						options = control.data('selectbox_options');
					if (control.hasClass('selectbox_disabled')) return;
					switch (event.keyCode) {
					case 9:
						// tab
					case 27:
						// esc
					case 13:
						// enter
					case 38:
						// up
					case 37:
						// left
					case 40:
						// down
					case 39:
						// right
						// Don't interfere with the keydown event!
						break;
					default:
						// Type to find
						if (!control.hasClass('selectbox-menuShowing')) showMenu(select);
						event.preventDefault();
						clearTimeout(typeTimer);
						typeSearch += String.fromCharCode(event.charCode || event.keyCode);
						options.find('A').each(function() {
							if (jQuery(this).text().substr(0, typeSearch.length).toLowerCase() === typeSearch.toLowerCase()) {
								addHover(select, jQuery(this).parent());
								keepOptionInView(select, jQuery(this).parent());
								return false;
							}
						});
						// Clear after a brief pause
						typeTimer = setTimeout(function() {
							typeSearch = '';
						}, 1000);
						break;
					}
				};
			var enable = function(select) {
					select = jQuery(select);
					select.attr('disabled', false);
					var control = select.data('selectbox-control');
					if (!control) return;
					control.removeClass('selectbox_disabled');
				};
			var disable = function(select) {
					select = jQuery(select);
					select.attr('disabled', true);
					var control = select.data('selectbox-control');
					if (!control) return;
					control.addClass('selectbox_disabled');
				};
			var setValue = function(select, value) {
					select = jQuery(select);
					select.val(value);
					value = select.val(); // IE9's select would be null if it was set with a non-exist options value
					if (value === null) { // So check it here and set it with the first option's value if possible
						value = select.children().first().val();
						select.val(value);
					}
					var control = select.data('selectbox-control');
					if (!control) return;
					var settings = select.data('selectbox-settings'),
						options = control.data('selectbox_options');
					// Update label
					setLabel(select);
					// Update control values
					options.find('.selectbox_selected').removeClass('selectbox_selected');
					options.find('A').each(function() {
						if (typeof(value) === 'object') {
							for (var i = 0; i < value.length; i++) {
								if (jQuery(this).attr('rel') == value[i]) {
									jQuery(this).parent().addClass('selectbox_selected');
								}
							}
						} else {
							if (jQuery(this).attr('rel') == value) {
								jQuery(this).parent().addClass('selectbox_selected');
							}
						}
					});
					if (settings.change) settings.change.call(select);
				};
			var setOptions = function(select, options) {
					select = jQuery(select);
					var control = select.data('selectbox-control'),
						settings = select.data('selectbox-settings');
					switch (typeof(data)) {
					case 'string':
						select.html(data);
						break;
					case 'object':
						select.html('');
						for (var i in data) {
							if (data[i] === null) continue;
							if (typeof(data[i]) === 'object') {
								var optgroup = jQuery('<optgroup label="' + i + '" />');
								for (var j in data[i]) {
									optgroup.append('<option value="' + j + '">' + data[i][j] + '</option>');
								}
								select.append(optgroup);
							} else {
								var option = jQuery('<option value="' + i + '">' + data[i] + '</option>');
								select.append(option);
							}
						}
						break;
					}
					if (!control) return;
					// Remove old options
					control.data('selectbox_options').remove();
					// Generate new options
					var type = control.hasClass('selectbox') ? 'dropdown' : 'inline';
					options = getOptions(select, type);
					control.data('selectbox_options', options);
					switch (type) {
					case 'inline':
						control.append(options);
						break;
					case 'dropdown':
						// Update label
						setLabel(select);
						jQuery("BODY").append(options);
						break;
					}
				};
			var disableSelection = function(selector) {
					jQuery(selector).css('MozUserSelect', 'none').bind('selectstart', function(event) {
						event.preventDefault();
					});
				};
			var generateOptions = function(self, options) {
					var li = jQuery('<li />'),
						a = jQuery('<a />');
					li.addClass(self.attr('class'));
					li.data(self.data());
					a.attr('rel', self.val()).text(self.text());
					li.append(a);
					if (self.attr('disabled')) li.addClass('selectbox_disabled');
					if (self.attr('selected')) li.addClass('selectbox_selected');
					options.append(li);
				};
			//
			// Public methods
			//
			switch (method) {
			case 'control':
				return jQuery(this).data('selectbox-control');
			case 'settings':
				if (!data) return jQuery(this).data('selectbox-settings');
				jQuery(this).each(function() {
					jQuery(this).data('selectbox-settings', jQuery.extend(true, jQuery(this).data('selectbox-settings'), data));
				});
				break;
			case 'options':
				// Getter
				if (data === undefined) return jQuery(this).data('selectbox-control').data('selectbox_options');
				// Setter
				jQuery(this).each(function() {
					setOptions(this, data);
				});
				break;
			case 'value':
				// Empty string is a valid value
				if (data === undefined) return jQuery(this).val();
				jQuery(this).each(function() {
					setValue(this, data);
				});
				break;
			case 'refresh':
				jQuery(this).each(function() {
					refresh(this);
				});
				break;
			case 'enable':
				jQuery(this).each(function() {
					enable(this);
				});
				break;
			case 'disable':
				jQuery(this).each(function() {
					disable(this);
				});
				break;
			case 'destroy':
				jQuery(this).each(function() {
					destroy(this);
				});
				break;
			default:
				jQuery(this).each(function() {
					init(this, method);
				});
				break;
			}
			return jQuery(this);
		}
	});
})(jQuery);

/* jQuery selectbox end */